language: [English](README.md) | [简体中文](README-ZH.md)

# flyme_annotation

> flyme_generator 生成器的注解.

## 安装

在项目配置文件 **pubspec.yaml** 中添加依赖:

```yaml
dependencies:
  # 生成器注解
  flyme_annotation:
    git:
      url: https://github.com/maybewaityou/flyme_annotation.git

# 生成器
dev_dependencies:
  flyme_generator:
    git:
      url: https://github.com/maybewaityou/flyme_generator.git
```

## 使用

### ViewModel 注解

```dart
port '{当前文件名}.g.dart';

@Properties([
  Property(name: "name", type: String),
  Property(name: "age", type: num),
  Property(
      name: "user",
      type: User,
      initial: '''User(name: "", age: -1, email: "")'''),
  Property(name: "foo", type: String),
  Property(name: "boo", type: String, initial: "something"),
])
class TestModel extends _ViewModelProxy {
  @override
  void init() {
    print("==== Test init ====");
  }
}
```

未设置 **initial** 字段:

* String: ''(空字符串).
* num/int/double: 0.
* bool: false.
* 其它类型: null.

### Functional Widget 注解

> 使用纯函数来定义组件 (**React** 纯函数思想)

```dart
port '{当前文件名}.g.dart';

@widget
Widget foo(BuildContext context, {int value, String title}) {
  // TODO: 编写组件内容
  return Text("value: $value - title: $title");
}
```

### 运行

运行编译命令, 生成相应文件

> flutter packages pub run build_runner build



## API

### Properties

Properties: 注解属性列表.

### Property

Property: 属性类:

- name: property's name.
- type: property's type.
- initial: property's initialized value.

### widget

widget: 标识函数为纯函数组件.



## 关联项目

[flyme_generator](https://github.com/maybewaityou/flyme_generator): flyme 生成器. 可根据 **Properties** 注解生成 **ViewModel**, 根据 **widget** 注解生成无状态组件.

[generator-flyme](https://github.com/maybewaityou/generator-flyme): yeoman 命令行工具. 可自动生成 **项目**/**包**/**原生插件**/**业务模块**/**界面**/**用例模板**等.



## License

MIT © [MeePwn](https://github.com/maybewaityou)